// Borland C++ Builder
// Copyright (c) 1995, 1998 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'GraphLnk.pas' rev: 3.00

#ifndef GraphLnkHPP
#define GraphLnkHPP
#include <Cross.hpp>
#include <Pointlst.hpp>
#include <ExtCtrls.hpp>
#include <Dialogs.hpp>
#include <Forms.hpp>
#include <Controls.hpp>
#include <Graphics.hpp>
#include <Classes.hpp>
#include <Messages.hpp>
#include <Windows.hpp>
#include <SysUtils.hpp>
#include <SysInit.hpp>
#include <System.hpp>

//-- user supplied -----------------------------------------------------------

namespace Graphlnk
{
//-- type declarations -------------------------------------------------------
typedef tagPOINT  ElementType;

typedef tagPOINT TDynamicArray[8190];

typedef double ElementType2;

typedef double TDynamicArray2[8190];

struct TArrow
{
	tagPOINT BegP;
	tagPOINT EndP;
	tagPOINT Ap1;
	tagPOINT Apc;
	tagPOINT Apd;
	double sina;
	double cosa;
	double xb;
	double yb;
} ;

enum TArrowStyle { asTriangle, asAngle };

enum TArrowPlace { apNone, apMiddle, apForward, apBackward, apBoth };

enum TEdgeDirect { edHorLeft, edHorRight, edVertUp, edVertDown, edDiagRightDown, edDiagRightUp, edDiagLeftDown, 
	edDiagLeftUp };

enum TControlPlace { cpStart, cpEnd };

enum TPinPointType { ppTopLeft, ppStartPoint, ppEndPoint };

typedef void __fastcall (__closure *TControlCrossEvent)(System::TObject* Sender, TControlPlace Place
	, Controls::TControl* Target, tagPOINT &CrossPoint);

typedef void __fastcall (__closure *TControlShapeEvent)(System::TObject* Sender, TControlPlace Place
	, Controls::TControl* Target, Extctrls::TShapeType &Shape);

typedef void __fastcall (__closure *TLinkShowHintEvent)(System::TObject* Sender, System::AnsiString 
	&HintStr, bool &CanShow, Forms::THintInfo &HintInfo);

struct TCMHintShow
{
	int Msg;
	Word Empty;
	Forms::THintInfo *AHintInfo;
	int Result;
} ;

class DELPHICLASS TGraphLink;
class PASCALIMPLEMENTATION TGraphLink : public Controls::TGraphicControl 
{
	typedef Controls::TGraphicControl inherited;
	
private:
	Pointlst::TPointList* FPoints;
	Controls::TControl* FStartControl;
	Controls::TControl* FEndControl;
	TShapeType FStartControlShape;
	TShapeType FEndControlShape;
	int FArrowWidth;
	int FArrowHeight;
	TArrowPlace FArrowPlace;
	TArrowStyle FArrowStyle;
	TEdgeDirect FDirection;
	int FContactDistance;
	Graphics::TPen* FEdgePen;
	Graphics::TPen* FArrowPen;
	Graphics::TBrush* FArrowBrush;
	TControlCrossEvent FOnControlCrossPoint;
	TControlShapeEvent FOnControlShape;
	TLinkShowHintEvent FOnShowHint;
	bool IsPinned;
	bool ToIsPinned;
	bool FromIsPinned;
	bool ViaUpdateLink;
	int TopSave;
	int LeftSave;
	Graphics::TCanvas* WorkingCanvas;
	tagPOINT CanvasPoint;
	bool MovedOnCanvas;
	TArrow Arrow1;
	TArrow Arrow2;
	TDynamicArray *PDA;
	int DynArrSizeNeeded;
	int NDrawPoints;
	void __fastcall ReadEdgeColor(Classes::TReader* Reader);
	void __fastcall WriteEdgeColor(Classes::TWriter* Writer);
	void __fastcall ReadArrowColor(Classes::TReader* Reader);
	void __fastcall WriteArrowColor(Classes::TWriter* Writer);
	void __fastcall ReadArrowBrushColor(Classes::TReader* Reader);
	void __fastcall WriteArrowBrushColor(Classes::TWriter* Writer);
	void __fastcall EvaluateTopLeftWH(void);
	void __fastcall EvaluateFromTo(void);
	void __fastcall EvaluateFrom(void);
	void __fastcall EvaluateTo(void);
	HIDESBASE void __fastcall Changed(void);
	void __fastcall MovePoints(void);
	void __fastcall DrawPointArray(void);
	void __fastcall AllocPointArray(void);
	void __fastcall FreePointArray(void);
	int __fastcall MiddleSegment(tagPOINT &MiddlePoint);
	void __fastcall ModifyStartPoint(const tagPOINT &P, bool CrossEvent);
	void __fastcall ModifyEndPoint(const tagPOINT &P, bool CrossEvent);
	void __fastcall PinningByStartPoint(void);
	void __fastcall PinningByEndPoint(void);
	void __fastcall PinningByControl(void);
	void __fastcall SetStartPoint(const tagPOINT &P);
	void __fastcall SetEndPoint(const tagPOINT &P);
	tagPOINT __fastcall GetStartPoint();
	tagPOINT __fastcall GetEndPoint();
	tagPOINT __fastcall GetTemp();
	void __fastcall SetStartControl(Controls::TControl* V);
	void __fastcall SetEndControl(Controls::TControl* V);
	void __fastcall SetArrowWidth(int V);
	void __fastcall SetArrowHeight(int V);
	void __fastcall SetArrowPlace(TArrowPlace V);
	void __fastcall SetArrowStyle(TArrowStyle V);
	void __fastcall SetDirection(TEdgeDirect V);
	void __fastcall SetContactDistance(int V);
	void __fastcall SetEdgePen(Graphics::TPen* V);
	void __fastcall SetArrowPen(Graphics::TPen* V);
	void __fastcall SetArrowBrush(Graphics::TBrush* V);
	MESSAGE void __fastcall HitTest(Messages::TWMNCHitTest &Message);
	MESSAGE void __fastcall CMHintShow(TCMHintShow &Message);
	
protected:
	virtual void __fastcall Paint(void);
	virtual void __fastcall DefineProperties(Classes::TFiler* Filer);
	DYNAMIC void __fastcall MouseDown(Controls::TMouseButton Button, Classes::TShiftState Shift, int X, 
		int Y);
	bool __fastcall PtOnArrow(int X, int Y);
	bool __fastcall PtOnEdge(int X, int Y, const tagPOINT &Pb, const tagPOINT &Pe);
	DYNAMIC void __fastcall DoControlCrossPoint(TControlPlace Place, Controls::TControl* Target, tagPOINT 
		&CrossPoint);
	DYNAMIC void __fastcall DoControlShape(TControlPlace Place, Controls::TControl* Target, Extctrls::TShapeType 
		&Shape);
	DYNAMIC void __fastcall DoLinkShowHint(System::AnsiString &HintStr, bool &CanShow, Forms::THintInfo 
		&HintInfo);
	
public:
	__fastcall virtual TGraphLink(Classes::TComponent* AOwner);
	__fastcall virtual TGraphLink(Classes::TComponent* AOwner, bool Clear);
	__fastcall virtual TGraphLink(Classes::TComponent* AOwner, const tagPOINT &StartP, const tagPOINT &
		EndP);
	__fastcall virtual ~TGraphLink(void);
	bool __fastcall PtOnLink(int X, int Y);
	tagPOINT __fastcall GetPosAlongEdge(int Percent);
	tagPOINT __fastcall GetNearestEdgePoint(const tagPOINT &P);
	void __fastcall UpdateLink(void);
	void __fastcall Print(Graphics::TCanvas* PrintCanvas, const tagPOINT &PinPoint, TPinPointType PinPointType
		);
	void __fastcall ExportToMetafile(System::AnsiString FName, System::AnsiString CreatedBy, System::AnsiString 
		Description, bool Enhanced);
	__property tagPOINT StartPoint = {read=GetStartPoint, write=SetStartPoint};
	__property tagPOINT EndPoint = {read=GetEndPoint, write=SetEndPoint};
	__property Controls::TControl* StartControl = {read=FStartControl, write=SetStartControl};
	__property Controls::TControl* EndControl = {read=FEndControl, write=SetEndControl};
	__property Pointlst::TPointList* Points = {read=FPoints};
	__property tagPOINT Temp = {read=GetTemp};
	
__published:
	void __fastcall StyleChanged(System::TObject* Sender);
	void __fastcall PointListChanged(System::TObject* Sender);
	__property int ArrowWidth = {read=FArrowWidth, write=SetArrowWidth, nodefault};
	__property int ArrowHeight = {read=FArrowHeight, write=SetArrowHeight, nodefault};
	__property TArrowPlace ArrowPlace = {read=FArrowPlace, write=SetArrowPlace, default=1};
	__property TArrowStyle ArrowStyle = {read=FArrowStyle, write=SetArrowStyle, nodefault};
	__property TEdgeDirect Direction = {read=FDirection, write=SetDirection, nodefault};
	__property int ContactDistance = {read=FContactDistance, write=SetContactDistance, nodefault};
	__property Graphics::TPen* EdgePen = {read=FEdgePen, write=SetEdgePen};
	__property Graphics::TPen* ArrowPen = {read=FArrowPen, write=SetArrowPen};
	__property Graphics::TBrush* ArrowBrush = {read=FArrowBrush, write=SetArrowBrush};
	__property TControlCrossEvent OnControlCrossPoint = {read=FOnControlCrossPoint, write=FOnControlCrossPoint
		};
	__property TControlShapeEvent OnControlShape = {read=FOnControlShape, write=FOnControlShape};
	__property TLinkShowHintEvent OnShowHint = {read=FOnShowHint, write=FOnShowHint};
	__property ShowHint ;
	__property ParentShowHint ;
	__property Enabled ;
	__property Visible ;
	__property DragCursor ;
	__property DragMode ;
	__property OnMouseDown ;
	__property OnMouseMove ;
	__property OnMouseUp ;
	__property OnDragDrop ;
	__property OnDragOver ;
	__property OnEndDrag ;
};

//-- var, const, procedure ---------------------------------------------------
#define MaxArrSize (Word)(8189)
#define MaxArrSize2 (Word)(8189)
extern PACKAGE void __fastcall Register(void);
extern PACKAGE int __fastcall Max(int A, int B);
extern PACKAGE int __fastcall Min(int A, int B);

}	/* namespace Graphlnk */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Graphlnk;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// GraphLnk
